Next.js starter your AI actually understands. Ship internal tools in days not weeks. Pre-order $199 $499 → [Get it now]

How to set default props in Vue

Setting default props is essential for creating robust Vue components that handle missing prop values gracefully while providing sensible fallbacks. As the creator of CoreUI, a widely used open-source UI library, I’ve implemented default props in thousands of Vue components to ensure backward compatibility and improve developer experience in enterprise applications. From my expertise, the most effective approach is to use the default option in props definitions with proper type checking. This method provides type safety, clear documentation, and automatic fallback behavior while maintaining component flexibility.

Use the default option in props definition to set fallback values for missing component properties.

<template>
  <div class="user-card">
    <h3>{{ name }}</h3>
    <p>{{ role }}</p>
    <p>Posts: {{ postsCount }}</p>
    <div :class="{ active: isActive }">
      {{ isActive ? 'Online' : 'Offline' }}
    </div>
  </div>
</template>

<script setup>
const props = defineProps({
  name: {
    type: String,
    default: 'Anonymous User'
  },
  role: {
    type: String,
    default: 'Member'
  },
  postsCount: {
    type: Number,
    default: 0
  },
  isActive: {
    type: Boolean,
    default: false
  }
})
</script>

Default props are defined using the default option within prop definitions. For primitive values like strings, numbers, and booleans, use direct values. For objects and arrays, always use functions that return new instances to avoid shared references between component instances. Default values are applied when props are undefined, providing predictable fallback behavior.

Best Practice Note:

This is the same approach we use in CoreUI Vue components for reliable prop handling and component flexibility.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Next.js starter your AI actually understands. Ship internal tools in days not weeks. Pre-order $199 $499 → [Get it now]

How to set default props in React

Setting default props is essential for creating robust React components that handle missing or undefined prop values gracefully while providing sensible fallbacks. As the creator of CoreUI, a widely used open-source UI library, I’ve implemented default props in thousands of React components to ensure reliable behavior, backward compatibility, and excellent developer experience in enterprise component libraries. From my expertise, the most modern approach is to use ES6 default parameters in function components. This method provides clear, readable code with TypeScript support while eliminating the need for runtime checks and additional component properties.

Use ES6 default parameters in function components for clean and TypeScript-friendly default props.

// Modern approach with ES6 default parameters
function Button({
  children = 'Click me',
  variant = 'primary',
  size = 'medium',
  disabled = false,
  onClick = () => {},
  type = 'button'
}) {
  const buttonClass = `btn btn-${variant} btn-${size}`

  return (
    <button
      className={buttonClass}
      disabled={disabled}
      onClick={onClick}
      type={type}
    >
      {children}
    </button>
  )
}

// TypeScript version with interface
interface ButtonProps {
  children?: React.ReactNode
  variant?: 'primary' | 'secondary' | 'danger'
  size?: 'small' | 'medium' | 'large'
  disabled?: boolean
  onClick?: () => void
  type?: 'button' | 'submit' | 'reset'
}

function TypedButton({
  children = 'Click me',
  variant = 'primary',
  size = 'medium',
  disabled = false,
  onClick = () => {},
  type = 'button'
}: ButtonProps) {
  return (
    <button
      className={`btn btn-${variant} btn-${size}`}
      disabled={disabled}
      onClick={onClick}
      type={type}
    >
      {children}
    </button>
  )
}

// Usage - all props are optional due to defaults
// <Button />
// <Button variant="danger" size="large">Delete</Button>

ES6 default parameters provide the cleanest syntax for default props in modern React. Destructure props in the function parameter list and assign default values directly. This approach works seamlessly with TypeScript by marking props as optional in the interface. Default parameters are applied when props are undefined, providing predictable behavior. This eliminates the need for the legacy defaultProps static property while providing better performance and clearer code intent.

Best Practice Note:

This is the same approach we use in CoreUI React components for clean, type-safe default prop handling. Use object destructuring with defaults for better readability, make props optional in TypeScript interfaces when they have defaults, and consider using union types for constrained prop values like button variants or sizes.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
8 Best Free Bootstrap Admin Templates for 2026 - Comparison & Reviews
8 Best Free Bootstrap Admin Templates for 2026 - Comparison & Reviews

What is globalThis in JavaScript?
What is globalThis in JavaScript?

How to Hide Scrollbar with CSS
How to Hide Scrollbar with CSS

How to Remove Underline from Link in CSS
How to Remove Underline from Link in CSS

Answers by CoreUI Core Team